Subject: Re: Options for Source Code Control: RCS v. SCCS v. CVS
From: Robert Collins <[email-masked]>
To: Richard Heintze <[email-masked]>
Cc: [email-masked]
Date: Sun, 11 Jul 2004 08:04:08 +1000

On Sun, 2004-07-11 at 03:09, Richard Heintze wrote:
> I need some help understanding how RCS works. I typed
> "info RCS" and felt confused.

Not surprisingly. RCS doesn't model what any modern revision control
system does.

> Is RCS like CVS in the sense that one runs a un*x
> deamon or windows service on a remote node and legions
> of programmers use a client implemented with sockets
> or pipes.

No.

> If so, (1) how do I start the service or deamon for
> RCS?
> 
>   (2) does RCS lock out other programmers while one 
> works on a file or is RCS like CVS and everyone merges
> their differences later?

RCS locks out everyone per file. One of CVS's big advances was the
ability to modify a file without locking everyone out.

> Are RCS and CVS the only open source programs for
> source code control? What is SCCS? I believe that is a
> propietary program and not avialable as open source.

There are many - offhand:
arch
aegis
cvs
darcs
monotone
rcs
subversion
vesta

I personally use arch - its offline work mode, built in distributed
operation & mirroring support make it a dream to use. It versions more
aspects of project trees than any other RCS I've encountered - it even
supports file modes, and symlinks.

> How does one decide between using RCS and CVS? Are
> they very similar?

Really, one doesn't. One chooses between anything other than CVS or RCS.
RCS is not suitable for programming projects, as each file is versioned
separately, the same goes for CVS.

Rob

-- 
GPG key available at: <http://www.robertcollins.net/keys.txt>.